## libgnatcoll 21.0.0

=== Makefile ===
##############################################################################
##                                                                          ##
##                              GNATCOLL LIBRARY                            ##
##                                                                          ##
##                         Copyright (C) 2017, AdaCore.                     ##
##                                                                          ##
## This library is free software;  you can redistribute it and/or modify it ##
## under terms of the  GNU General Public License  as published by the Free ##
## Software  Foundation;  either version 3,  or (at your  option) any later ##
## version. This library is distributed in the hope that it will be useful, ##
## but WITHOUT ANY WARRANTY;  without even the implied warranty of MERCHAN# ##
## TABILITY or FITNESS FOR A PARTICULAR PURPOSE.                            ##
##                                                                          ##
## As a special exception under Section 7 of GPL version 3, you are granted ##
## additional permissions described in the GCC Runtime Library Exception,   ##
## version 3.1, as published by the Free Software Foundation.               ##
##                                                                          ##
## You should have received a copy of the GNU General Public License and    ##
## a copy of the GCC Runtime Library Exception along with this program;     ##
## see the files COPYING3 and COPYING.RUNTIME respectively.  If not, see    ##
## <http://www.gnu.org/licenses/>.                                          ##
##                                                                          ##
##############################################################################

# Makefile targets
# ----------------
#
# Setup:                   make [VAR=VALUE] setup (see below)
# Build:                   make
# Install:                 make install

# Variables which can be set:
#
# General:
#
#   prefix        : root install directory
#   ENABLE_SHARED : yes / no (or empty)
#   BUILD         : DEBUG PROD
#   PROCESSORS    : nb parallel compilations (0 to use all cores)
#   TARGET        : target triplet for cross-compilation
#   INTEGRATED    : installs the project as part of the compiler installation;
#                   this adds NORMALIZED_TARGET subdir to prefix
#
# Project specific:
#
#   GNATCOLL_MMAP    : whether MMAP is supported (yes/no)
#                      default is "yes"; has no effect on Windows
#   GNATCOLL_MADVISE : whether MADVISE is supported (yes/no)
#                      default is "yes"; has no effect on Windows

# helper programs
CAT := cat
ECHO  := echo
WHICH := which

# check for out-of-tree build
SOURCE_DIR := $(dir $(MAKEFILE_LIST))
ifeq ($(SOURCE_DIR),./)
  RBD=
  GNATCOLL_GPR=gnatcoll.gpr
  MAKEPREFIX=
else
  RBD=--relocate-build-tree
  GNATCOLL_GPR=$(SOURCE_DIR)/gnatcoll.gpr
  MAKEPREFIX=$(SOURCE_DIR)/
endif

TARGET := $(shell gcc -dumpmachine)
NORMALIZED_TARGET := $(subst normalized_target:,,$(wordlist 6,6,$(shell gprconfig  --config=ada --target=$(TARGET) --mi-show-compilers)))
ifeq ($(NORMALIZED_TARGET),)
  $(error No toolchain found for target "$(TARGET)")
endif

GNATCOLL_OS := $(if $(findstring darwin,$(NORMALIZED_TARGET)),osx,$(if $(findstring windows,$(NORMALIZED_TARGET)),windows,unix))

prefix := $(dir $(shell $(WHICH) gnatls))..
GNATCOLL_VERSION := $(shell $(CAT) $(SOURCE_DIR)/version_information)
GNATCOLL_MMAP := yes
GNATCOLL_MADVISE := yes

BUILD         = PROD
PROCESSORS    = 0
BUILD_DIR     =
ENABLE_SHARED = yes
INTEGRATED    = no

all: build

# Load current setup if any
-include makefile.setup

GTARGET=--target=$(NORMALIZED_TARGET)

ifeq ($(ENABLE_SHARED), yes)
   LIBRARY_TYPES=static relocatable static-pic
else
   LIBRARY_TYPES=static
endif

ifeq ($(INTEGRATED), yes)
   integrated_install=/$(NORMALIZED_TARGET)
endif


GPR_VARS=-XGNATCOLL_MMAP=$(GNATCOLL_MMAP) \
	 -XGNATCOLL_MADVISE=$(GNATCOLL_MADVISE) \
	 -XGNATCOLL_VERSION=$(GNATCOLL_VERSION) \
	 -XGNATCOLL_OS=$(GNATCOLL_OS) \
	 -XBUILD=$(BUILD)

# Used to pass extra options to GPRBUILD, like -d for instance
GPRBUILD_OPTIONS=

BUILDER=gprbuild -p -m $(GTARGET) $(RBD) -j$(PROCESSORS) $(GPR_VARS) \
	$(GPRBUILD_OPTIONS)
INSTALLER=gprinstall -p -f $(GTARGET) $(GPR_VARS) \
	$(RBD) --sources-subdir=include/gnatcoll --prefix=$(prefix)$(integrated_install)
CLEANER=gprclean -q $(RBD) $(GTARGET)
UNINSTALLER=$(INSTALLER) -p -f --install-name=gnatcoll --uninstall

#########
# build #
#########

build: $(LIBRARY_TYPES:%=build-%)

build-%:
	$(BUILDER) -XLIBRARY_TYPE=$* -XXMLADA_BUILD=$* -XGPR_BUILD=$* \
		$(GPR_VARS) $(GNATCOLL_GPR)

###########
# Install #
###########

uninstall:
ifneq (,$(wildcard $(prefix)$(integrated_install)/share/gpr/manifests/gnatcoll))
	$(UNINSTALLER) $(GNATCOLL_GPR)
endif

install: uninstall $(LIBRARY_TYPES:%=install-%)

install-%:
	$(INSTALLER) -XLIBRARY_TYPE=$* -XXMLADA_BUILD=$* -XGPR_BUILD=$* \
		--build-name=$* $(GPR_VARS) \
		--build-var=LIBRARY_TYPE --build-var=GNATCOLL_BUILD \
		--build-var=GNATCOLL_CORE_BUILD $(GNATCOLL_GPR)

###########
# Cleanup #
###########

clean: $(LIBRARY_TYPES:%=clean-%)

clean-%:
	-$(CLEANER) -XLIBRARY_TYPE=$* -XXMLADA_BUILD=$* -XGPR_BUILD=$* \
		$(GPR_VARS) $(GNATCOLL_GPR)

#########
# setup #
#########

.SILENT: setup

setup:
	$(ECHO) "prefix=$(prefix)" > makefile.setup
	$(ECHO) "ENABLE_SHARED=$(ENABLE_SHARED)" >> makefile.setup
	$(ECHO) "INTEGRATED=$(INTEGRATED)" >> makefile.setup
	$(ECHO) "BUILD=$(BUILD)" >> makefile.setup
	$(ECHO) "PROCESSORS=$(PROCESSORS)" >> makefile.setup
	$(ECHO) "TARGET=$(TARGET)" >> makefile.setup
	$(ECHO) "SOURCE_DIR=$(SOURCE_DIR)" >> makefile.setup
	$(ECHO) "GNATCOLL_OS=$(GNATCOLL_OS)" >> makefile.setup
	$(ECHO) "GNATCOLL_VERSION=$(GNATCOLL_VERSION)" >> makefile.setup
	$(ECHO) "GNATCOLL_MMAP=$(GNATCOLL_MMAP)" >> makefile.setup
	$(ECHO) "GNATCOLL_MADVISE=$(GNATCOLL_MADVISE)" >> makefile.setup

# Let gprbuild handle parallelisation. In general, we don't support parallel
# runs in this Makefile, as concurrent gprinstall processes may crash.
.NOTPARALLEL:

=== debian/changelog ===
libgnatcoll (21.0.0-4) unstable; urgency=medium

  * Source upload forcing rebuild on buildds for all,amd64.
  * Standards-Version: 4.5.1.

 -- Nicolas Boulenguez <nicolas@debian.org>  Tue, 22 Dec 2020 10:58:09 +0100

libgnatcoll (21.0.0-3) unstable; urgency=medium

  * Reupload to unstable for gnat-10 transition.
  * Add myself to Uploaders.

 -- Ludovic Brenta <lbrenta@debian.org>  Sat, 12 Dec 2020 17:10:38 +0100

libgnatcoll (21.0.0-2) experimental; urgency=medium

  * Restrict versions of build dependencies, fixing the build of indirect
    reverse dependencies in experimental where ALI versions do not change.

 -- Nicolas Boulenguez <nicolas@debian.org>  Sun, 15 Nov 2020 19:00:23 +0000

libgnatcoll (21.0.0-1) experimental; urgency=medium

  * New upstream release (no renaming in experimental).
  * Upstream now grants the GCC runtime exception to GPL-3+.
    Relicense Debian packaging accordingly.
  * Add missing copyright stanza for documentation.
  * Upstream recommends to watch github instead of the community website.
  * Build and install doc registration into GNAT Programming Studio.
  * Change section from misc to libdevel.
  * Drop obsolete sphinx build-dependency on texlive-plain-generic.

 -- Nicolas Boulenguez <nicolas@debian.org>  Tue, 20 Oct 2020 21:08:42 +0000

libgnatcoll (20-1) experimental; urgency=medium

  * New upstream release, built with gnat-10. Rename lib and -dev accordingly.
  * Debhelper 13.
  * Split -arch and -indep build-dependencies.
  * Drop obsolete Pre-Depends.
  * Apply CFLAGS to gnatcoll_support.c, forgotten in a forwarded patch.
  * Cherry-pick upstream commits ensuring compatibility with current gnatprj.
  * link-with-libdl.diff on unix, not on osx.
  * Empty Linker_Options in installed project.
  * Pass build flags via the environment instead of Make.
  * Replace MAKE with dh_auto_build, which computes options like -j.

 -- Nicolas Boulenguez <nicolas@debian.org>  Fri, 22 May 2020 07:16:53 +0000

=== debian/control ===
Source: libgnatcoll
Priority: optional
Section: libdevel
Maintainer: Nicolas Boulenguez <nicolas@debian.org>
Uploaders: Ludovic Brenta <lbrenta@debian.org>
Build-Depends:
 debhelper-compat (= 13),
Build-Depends-Arch:
 dh-ada-library (>= 7.2),
 dh-sequence-ada-library,
 gnat,
# This line is parsed to set gnat version:
 gnat-10,
 gprbuild (>= 2021.0.0.0778b109-2),
 libgnatprj8-dev (>= 2021.0.0.0778b109-2),
# Implicit libc6-dev provides: iconv, syslog.
Build-Depends-Indep:
 dh-sequence-sphinxdoc,
# Sphinx >= 1.6 uses the latexmk driver:
 latexmk,
 python3-sphinx,
 sphinx-common,
 texlive-fonts-recommended,
 texlive-latex-extra,
Homepage: https://github.com/AdaCore/gnatcoll-core
Standards-Version: 4.5.1
Rules-Requires-Root: no
Vcs-Browser: https://salsa.debian.org/debian/libgnatcoll
Vcs-Git: https://salsa.debian.org/debian/libgnatcoll.git

Package: libgnatcoll19-dev
# This line is parsed to set the Ada Library Information version.
Architecture: any
Depends: ${misc:Depends}, ${ada:Depends}
Suggests: libgnatcoll-doc
Description: GNATColl, general purpose Ada library
 The GNAT Component Collection deals with: module tracing, efficient
 file IO, static string searching (Boyer-Moore), e-mails and
 mailboxes, Ravenscar tasking profiles, storage pools, JSON, logging,
 shell scripting. Components relying on external dependencies are
 distributed in separate packages.
 .
 This package contains the static library and Ada specifications.

Package: libgnatcoll-doc
Section: doc
Architecture: all
Multi-Arch: foreign
Built-Using: ${sphinxdoc:Built-Using}
Depends: ${misc:Depends}, ${sphinxdoc:Depends}
Suggests: gnat
Description: GNATColl, general purpose Ada library (documentation)
 The GNAT Component Collection deals with: module tracing, efficient
 file IO, static string searching (Boyer-Moore), e-mails and
 mailboxes, Ravenscar tasking profiles, storage pools, JSON, logging,
 shell scripting. Components relying on external dependencies are
 distributed in separate packages.
 .
 This package contains the documentation in text, PDF and HTML.

Package: libgnatcoll19
# This line is parsed to set the Shared Object version.
Section: libs
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Multi-Arch: same
Description: GNATColl, general purpose Ada library (runtime)
 The GNAT Component Collection deals with: module tracing, efficient
 file IO, static string searching (Boyer-Moore), e-mails and
 mailboxes, Ravenscar tasking profiles, storage pools, JSON, logging,
 shell scripting. Components relying on external dependencies are
 distributed in separate packages.
 .
 This package contains the runtime shared library.

=== debian/rules ===
#!/usr/bin/make -f
# Build script for GNATColl in Debian.
# Copyright (c) 2014-2020 Nicolas Boulenguez <nicolas@debian.org>

# This build script is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License as
# published by the Free Software Foundation; either version 3 of the
# License, or (at your option) any later version.

# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# General Public License for more details.

# On Debian systems, the full text of the GPL is in the file
# /usr/share/common-licenses/GPL-3.

$(foreach line,$(shell sed -n '\
  s/^ gnat-\([0-9.]\+\),$$/              GNAT_VERSION:=\1     /p; \
  s/^Package: libgnatcoll\([0-9.]\+\)$$/ GNATCOLL_VERSION:=\1 /p; \
  ' debian/control),$(eval $(line)))

DPKG_EXPORT_BUILDFLAGS := 1
DEB_BUILD_MAINT_OPTIONS := hardening=+all
DEB_LDFLAGS_MAINT_APPEND := \
  -Wl,--no-allow-shlib-undefined \
  -Wl,--no-copy-dt-needed-entries \
  -Wl,--no-undefined
include /usr/share/dpkg/architecture.mk
include /usr/share/dpkg/buildflags.mk
include $(wildcard /usr/share/ada/debian_packaging-$(GNAT_VERSION).mk)
# wildcard means: not during -indep builds.

%:
	dh $@

.PHONY: $(addprefix override_dh_auto_,configure clean build-arch build-indep test install)
# Disable autodetection of upstream targets.
# We want to avoid clean and install.  Moreover, test does not exist,
# but while figuring this during -indep builds, debhelper
# would run Make and Make would fail to run gprconfig.

# static and relocatable, but not static-pic
# Prevent Makefile from messing with gprconfig
# (NORMALIZED_TARGET is wrong at least for i386 and hurd-i386).
override_dh_auto_build-arch:
	dh_auto_build -- \
	  TARGET=$(DEB_HOST_GNU_TYPE) \
	  NORMALIZED_TARGET=$(DEB_HOST_GNU_TYPE) \
	  LIBRARY_TYPES='static relocatable' \
	  GNATCOLL_VERSION=$(GNATCOLL_VERSION) \
	  GPRBUILD_OPTIONS='$(BUILDER_OPTIONS)'

override_dh_auto_build-indep:
ifeq (,$(filter nodoc,$(DEB_BUILD_OPTIONS)))
	dh_auto_build -- -C docs html latexpdf text
endif

# Force regeneration of runtime.py.
override_dh_auto_configure:
	rm -f distrib/gnatcoll/runtime.py
override_dh_auto_build-indep: distrib/gnatcoll/runtime.py
distrib/gnatcoll/runtime.py:
	cd distrib && python3 gen_gps.py

# Avoid a warning about doc-main-package.
doc_pkg := libgnatcoll-doc
please_644 := debian/$(doc_pkg)/usr/share/doc/$(doc_pkg)/examples/coders/base64-demo
override_dh_installdocs:
	dh_installdocs --package=$(doc_pkg) --doc-main-package=$(doc_pkg)
	dh_installdocs --remaining-packages
override_dh_installexamples:
	dh_installexamples --package=$(doc_pkg) --doc-main-package=$(doc_pkg)
	dh_installexamples --remaining-packages
  # Fix a silly permission.
  # The file does not exist during -arch builds.
	if test -f $(please_644); then chmod 644 $(please_644); fi

=== debian/tests/control ===
Tests: projects
Depends: @, gprbuild

=== debian/watch ===
version=4

opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%gnatcoll-core-$1.tar.gz%" \
https://github.com/AdaCore/gnatcoll-core/tags \
(?:.*?/)?v?(\d[\d.]*)\.tar\.gz

## libgnatcoll 22.1.0

=== debian/changelog ===
libgnatcoll (22.1.0-3) unstable; urgency=medium

  * Reupload to unstable for the gnat-11 transition
  * Configure branch names for git-buildpackage
  * Require dh-ada-library 7.5, which generates ada:Depends differently

 -- Nicolas Boulenguez <nicolas@debian.org>  Sun, 08 May 2022 18:16:38 +0200

libgnatcoll (22.1.0-2) experimental; urgency=medium

  * Rebuild with gnat-11 (>= 11.2.0-19).
    A change in s-oscons.ads breaks ALI checksums.

 -- Nicolas Boulenguez <nicolas@debian.org>  Sun, 03 Apr 2022 12:35:35 +0000

libgnatcoll (22.1.0-1) experimental; urgency=medium

  * Build new upstream snapshot with gnat-11 in experimental.
    Rename lib and -dev accordingly.
  * Build-Depend-Indep: tex-gyre. Closes: #997452.
  * Update standards version.
  * Adapt to new debian_packaging.mk from gnat package.
  * Add upstream metadata.
  * Remove unneeded filenamemangle uscan option.

 -- Nicolas Boulenguez <nicolas@debian.org>  Sun, 13 Mar 2022 14:38:22 +0000

=== debian/control ===
--- 
+++ 
@@ -6,13 +6,12 @@
 Build-Depends:
  debhelper-compat (= 13),
 Build-Depends-Arch:
- dh-ada-library (>= 7.2),
+ dh-ada-library (>= 7.5),
  dh-sequence-ada-library,
  gnat,
-# This line is parsed to set gnat version:
- gnat-10,
+ gnat-11 (>= 11.2.0-19),
  gprbuild (>= 2021.0.0.0778b109-2),
- libgnatprj8-dev (>= 2021.0.0.0778b109-2),
+ libgnatprj9-dev (>= 2022.0.0-2),
 # Implicit libc6-dev provides: iconv, syslog.
 Build-Depends-Indep:
  dh-sequence-sphinxdoc,
@@ -20,15 +19,17 @@
  latexmk,
  python3-sphinx,
  sphinx-common,
+# sphinx-doc requires tgterms.sty:
+ tex-gyre,
  texlive-fonts-recommended,
  texlive-latex-extra,
 Homepage: https://github.com/AdaCore/gnatcoll-core
-Standards-Version: 4.5.1
+Standards-Version: 4.6.0
 Rules-Requires-Root: no
 Vcs-Browser: https://salsa.debian.org/debian/libgnatcoll
 Vcs-Git: https://salsa.debian.org/debian/libgnatcoll.git
 
-Package: libgnatcoll19-dev
+Package: libgnatcoll20-dev
 # This line is parsed to set the Ada Library Information version.
 Architecture: any
 Depends: ${misc:Depends}, ${ada:Depends}
@@ -58,7 +59,7 @@
  .
  This package contains the documentation in text, PDF and HTML.
 
-Package: libgnatcoll19
+Package: libgnatcoll20
 # This line is parsed to set the Shared Object version.
 Section: libs
 Architecture: any

=== debian/rules ===
--- 
+++ 
@@ -1,6 +1,6 @@
 #!/usr/bin/make -f
 # Build script for GNATColl in Debian.
-# Copyright (c) 2014-2020 Nicolas Boulenguez <nicolas@debian.org>
+# Copyright (c) 2014-2022 Nicolas Boulenguez <nicolas@debian.org>
 
 # This build script is free software; you can redistribute it and/or
 # modify it under the terms of the GNU General Public License as
@@ -15,10 +15,8 @@
 # On Debian systems, the full text of the GPL is in the file
 # /usr/share/common-licenses/GPL-3.
 
-$(foreach line,$(shell sed -n '\
-  s/^ gnat-\([0-9.]\+\),$$/              GNAT_VERSION:=\1     /p; \
-  s/^Package: libgnatcoll\([0-9.]\+\)$$/ GNATCOLL_VERSION:=\1 /p; \
-  ' debian/control),$(eval $(line)))
+GNATCOLL_VERSION != \
+  sed -n '/^Package: libgnatcoll\([0-9.]\+\)$$/{s//\1/p;q}' debian/control
 
 DPKG_EXPORT_BUILDFLAGS := 1
 DEB_BUILD_MAINT_OPTIONS := hardening=+all
@@ -26,9 +24,11 @@
   -Wl,--no-allow-shlib-undefined \
   -Wl,--no-copy-dt-needed-entries \
   -Wl,--no-undefined
+DEB_GPRBUILDFLAGS_NO_J := 1
 include /usr/share/dpkg/architecture.mk
 include /usr/share/dpkg/buildflags.mk
-include $(wildcard /usr/share/ada/debian_packaging-$(GNAT_VERSION).mk)
+include /usr/share/dpkg/buildopts.mk
+include $(wildcard /usr/share/ada/debian_packaging.mk)
 # wildcard means: not during -indep builds.
 
 %:
@@ -49,11 +49,13 @@
 	  NORMALIZED_TARGET=$(DEB_HOST_GNU_TYPE) \
 	  LIBRARY_TYPES='static relocatable' \
 	  GNATCOLL_VERSION=$(GNATCOLL_VERSION) \
-	  GPRBUILD_OPTIONS='$(BUILDER_OPTIONS)'
+	  GPRBUILD_OPTIONS='$(GPRBUILDFLAGS)' \
+	  $(addprefix PROCESSORS=,$(DEB_BUILD_OPTION_PARALLEL))
 
 override_dh_auto_build-indep:
 ifeq (,$(filter nodoc,$(DEB_BUILD_OPTIONS)))
-	dh_auto_build -- -C docs html latexpdf text
+	dh_auto_build --sourcedirectory=docs -- html latexpdf text \
+	  $(addprefix SPHINXOPTS=-j,$(DEB_BUILD_OPTION_PARALLEL))
 endif
 
 # Force regeneration of runtime.py.

=== debian/watch ===
version=4

# When upstream doesn’t release tags:
# wget https://github.com/AdaCore/gnatcoll-core/archive/c06dcc5e2515b1a18212a36aa80f06743b4863d1.tar.gz -O../libgnatcoll_22.1.0.orig.tar.gz

https://github.com/AdaCore/gnatcoll-core/tags \
(?:.*?/)?v?(\d[\d.]*)\.tar\.gz

## libgnatcoll 23.0.0

=== debian/changelog ===
libgnatcoll (23.0.0-3) unstable; urgency=medium

  * Break/Replace libgnatcoll*-dev since oldstable. Closes: #1034920 .

 -- Nicolas Boulenguez <nicolas@debian.org>  Wed, 10 May 2023 23:05:28 +0200

libgnatcoll (23.0.0-2) unstable; urgency=medium

  * Reupload to unstable for the gnat-12 transition.
  * Standards-Version: 4.6.2 (no changes).

 -- Nicolas Boulenguez <nicolas@debian.org>  Tue, 27 Dec 2022 01:21:20 +0100

libgnatcoll (23.0.0-1) experimental; urgency=medium

  * Build with unicode 15. No -dev renamings in experimental.
  * New upstream release, depending on python3-sphinx-rtd-theme.

 -- Nicolas Boulenguez <nicolas@debian.org>  Sat, 26 Nov 2022 23:52:58 +0000

libgnatcoll (23~20220817-1) experimental; urgency=medium

  * New snapshot applying forwarded patches and fixing permissions.
  * Adapt to dh-ada-library 8.1.
    gprinstall-no-artifacts.diff (no gprinstall during -indep builds).
  * Explicitly run gprconfig in order to ensure compiler versions.
  * Avoid dh_auto_build launching parallel sphinx job managers.

 -- Nicolas Boulenguez <nicolas@debian.org>  Mon, 29 Aug 2022 16:23:51 +0000

libgnatcoll (23~20220803-1) experimental; urgency=medium

  * Build new snapshot with gnat-12 for experimental.
    Rename lib and -dev package accordingly.
  * watch: remove obsolete comment
  * Standards-Version: 4.6.1 (no change)
  * Use a stamp to force regeneration of runtime.py
  * Clean a GNAT temporary file forgotten by the build

 -- Nicolas Boulenguez <nicolas@debian.org>  Mon, 08 Aug 2022 11:01:11 +0200

=== debian/control ===
--- 
+++ 
@@ -6,31 +6,32 @@
 Build-Depends:
  debhelper-compat (= 13),
 Build-Depends-Arch:
- dh-ada-library (>= 7.5),
+ dh-ada-library (>= 8.1),
  dh-sequence-ada-library,
- gnat,
- gnat-11 (>= 11.2.0-19),
+ gnat-12,
  gprbuild (>= 2021.0.0.0778b109-2),
- libgnatprj9-dev (>= 2022.0.0-2),
+ libgnatprj10-dev,
 # Implicit libc6-dev provides: iconv, syslog.
 Build-Depends-Indep:
  dh-sequence-sphinxdoc,
 # Sphinx >= 1.6 uses the latexmk driver:
  latexmk,
  python3-sphinx,
+ python3-sphinx-rtd-theme,
  sphinx-common,
 # sphinx-doc requires tgterms.sty:
  tex-gyre,
  texlive-fonts-recommended,
  texlive-latex-extra,
 Homepage: https://github.com/AdaCore/gnatcoll-core
-Standards-Version: 4.6.0
+Standards-Version: 4.6.2
 Rules-Requires-Root: no
 Vcs-Browser: https://salsa.debian.org/debian/libgnatcoll
 Vcs-Git: https://salsa.debian.org/debian/libgnatcoll.git
 
-Package: libgnatcoll20-dev
-# This line is parsed to set the Ada Library Information version.
+Package: libgnatcoll21-dev
+Breaks: libgnatcoll17-dev, libgnatcoll18-dev, libgnatcoll19-dev, libgnatcoll20-dev
+Replaces: libgnatcoll17-dev, libgnatcoll18-dev, libgnatcoll19-dev, libgnatcoll20-dev
 Architecture: any
 Depends: ${misc:Depends}, ${ada:Depends}
 Suggests: libgnatcoll-doc
@@ -59,7 +60,7 @@
  .
  This package contains the documentation in text, PDF and HTML.
 
-Package: libgnatcoll20
+Package: libgnatcoll21
 # This line is parsed to set the Shared Object version.
 Section: libs
 Architecture: any

=== debian/rules ===
#!/usr/bin/make -f
# Build script for GNATColl in Debian.
# Copyright (c) 2014-2022 Nicolas Boulenguez <nicolas@debian.org>

# This build script is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License as
# published by the Free Software Foundation; either version 3 of the
# License, or (at your option) any later version.

# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# General Public License for more details.

# On Debian systems, the full text of the GPL is in the file
# /usr/share/common-licenses/GPL-3.

DPKG_EXPORT_BUILDFLAGS := 1
DEB_BUILD_MAINT_OPTIONS := hardening=+all
DEB_LDFLAGS_MAINT_APPEND := \
  -Wl,--no-allow-shlib-undefined \
  -Wl,--no-copy-dt-needed-entries \
  -Wl,--no-undefined
include /usr/share/dpkg/buildflags.mk
include /usr/share/dpkg/buildopts.mk
include $(wildcard /usr/share/ada/packaging.mk)
# wildcard means: not during -indep builds.

%:
	dh $@

.PHONY: $(addprefix override_dh_auto_,configure clean build-arch \
  build-indep test install-arch install-indep)
# Disable autodetection of upstream targets.
# We want to avoid clean and install.  Moreover, test does not exist,
# but while figuring this during -indep builds, debhelper
# would run Make and Make would fail to run gprconfig.

gpr_vars := \
  -XGNATCOLL_VERSION=$(gnatcoll_SO_VERSION) \
  -XGNATCOLL_BUILD_MODE=PROD \
  # EOL

# Prevent Makefile from messing with gprconfig
# (NORMALIZED_TARGET is wrong at least for i386 and hurd-i386).
override_dh_auto_build-arch:
	gprconfig --batch $(GPRCONFIGFLAGS)
	gprbuild gnatcoll.gpr $(GPRBUILDFLAGS) $(gpr_vars) \
	  -XLIBRARY_TYPE=static
	gprbuild gnatcoll.gpr $(GPRBUILDFLAGS) $(gpr_vars) \
	  -XLIBRARY_TYPE=relocatable

override_dh_auto_install-arch:
	gprinstall gnatcoll.gpr $(gpr_vars) \
	  -XLIBRARY_TYPE=static $(static_GPRINSTALLFLAGS)
	gprinstall gnatcoll.gpr $(gpr_vars) \
	  -XLIBRARY_TYPE=relocatable $(call shared_GPRINSTALLFLAGS,gnatcoll)

override_dh_auto_build-indep:
ifeq (,$(filter nodoc,$(DEB_BUILD_OPTIONS)))
	$(MAKE) -Cdocs html latexpdf text \
	  $(DEB_BUILD_OPTION_PARALLEL:%=SPHINXOPTS=-j%)
endif

# Force regeneration of distrib/gnatcoll/runtime.py.
override_dh_auto_build-indep: runtime-stamp
runtime-stamp:
	cd distrib && python3 gen_gps.py
	touch $@

# Avoid a warning about doc-main-package.
doc_pkg := libgnatcoll-doc
execute_before_dh_installdocs:
	dh_installdocs --package=$(doc_pkg) --doc-main-package=$(doc_pkg)
execute_before_dh_installexamples:
	dh_installexamples --package=$(doc_pkg) --doc-main-package=$(doc_pkg)

## libgnatcoll 24.1.20230921

=== Makefile ===
--- 
+++ 
@@ -55,6 +55,12 @@
 
 # check for out-of-tree build
 SOURCE_DIR := $(dir $(MAKEFILE_LIST))
+
+# make -f with absolute path to current directory Makefile is in-tree build
+ifeq ($(SOURCE_DIR), $(shell pwd)/)
+	SOURCE_DIR := ./
+endif
+
 ifeq ($(SOURCE_DIR),./)
   RBD=
   GNATCOLL_GPR=gnatcoll.gpr
@@ -83,6 +89,7 @@
 BUILD_DIR     =
 ENABLE_SHARED = yes
 INTEGRATED    = no
+GNATCOV       =
 
 all: build
 
@@ -97,9 +104,21 @@
    LIBRARY_TYPES=static
 endif
 
+ifeq ($(GNATCOV), yes)
+   LIBRARY_TYPES=static
+   GNATCOV_RTS=gnatcovrts
+   GNATCOV_BUILD_OPTS=--src-subdirs=gnatcov-instr --implicit-with=gnatcov_rts
+   GNATCOV_PROJECT_PATH=GPR_PROJECT_PATH=$(CURDIR)/gnatcov_rts/share/gpr:$(GPR_PROJECT_PATH)
+else
+   GNATCOV_RTS=
+   GNATCOV_BUILD_OPTS=
+   GNATCOV_PROJECT_PATH=
+endif
+
 ifeq ($(INTEGRATED), yes)
    integrated_install=/$(NORMALIZED_TARGET)
 endif
+
 
 
 GPR_VARS=-XGNATCOLL_MMAP=$(GNATCOLL_MMAP) \
@@ -111,8 +130,9 @@
 # Used to pass extra options to GPRBUILD, like -d for instance
 GPRBUILD_OPTIONS=
 
-BUILDER=gprbuild -p -m $(GTARGET) $(RBD) -j$(PROCESSORS) $(GPR_VARS) \
-	$(GPRBUILD_OPTIONS)
+BUILDER=$(GNATCOV_PROJECT_PATH) gprbuild -p -m $(GTARGET) $(RBD) \
+        -j$(PROCESSORS) $(GPR_VARS) \
+	$(GPRBUILD_OPTIONS) $(GNATCOV_BUILD_OPTS)
 INSTALLER=gprinstall -p -f $(GTARGET) $(GPR_VARS) \
 	$(RBD) --sources-subdir=include/gnatcoll --prefix=$(prefix)$(integrated_install)
 CLEANER=gprclean -q $(RBD) $(GTARGET)
@@ -124,9 +144,20 @@
 
 build: $(LIBRARY_TYPES:%=build-%)
 
-build-%:
+build-%: $(GNATCOV_RTS)
+ifeq ($(GNATCOV), yes)
+	gnatcov instrument -P $(GNATCOLL_GPR) $(RBD) \
+		--no-subprojects --level=stmt+decision
+endif
 	$(BUILDER) -XLIBRARY_TYPE=$* -XXMLADA_BUILD=$* -XGPR_BUILD=$* \
-		$(GPR_VARS) $(GNATCOLL_GPR)
+		$(GPR_VARS) $(GNATCOLL_GPR) -v
+
+###################
+# Instrumentation #
+###################
+
+gnatcovrts:
+	gnatcov setup --prefix=gnatcov_rts
 
 ###########
 # Install #

=== debian/changelog ===
libgnatcoll (24.1.20230921-6build2) questing; urgency=medium

  * No-change rebuild for gnat ABI, triggered by glibc 2.42.

 -- Matthias Klose <doko@ubuntu.com>  Sun, 21 Sep 2025 14:14:54 +0200

libgnatcoll (24.1.20230921-6build1) questing; urgency=medium

  * No-change with SOURCE_DATE_EPOCH fixed in libgnatprj-dev

 -- Graham Inggs <ginggs@ubuntu.com>  Mon, 19 May 2025 13:03:20 +0000

libgnatcoll (24.1.20230921-6) unstable; urgency=medium

  * Reupload to unstable for the gnat-14 transition.

 -- Nicolas Boulenguez <nicolas@debian.org>  Mon, 10 Mar 2025 08:40:05 +0100

libgnatcoll (24.1.20230921-5) experimental; urgency=medium

  * Build in experimental with gnat-14.
  * Install documentation to now unversioned -dev doc directory.
  * Enable salsa continuous integration via salsa-ci.yml.
  * Simplify debian/rules.

 -- Nicolas Boulenguez <nicolas@debian.org>  Fri, 21 Feb 2025 17:00:15 +0000

libgnatcoll (24.1.20230921-4) unstable; urgency=medium

  * Reupload to unstable for the gnat-13/time_t64 transition.
    Closes: #1061631.

 -- Nicolas Boulenguez <nicolas@debian.org>  Sun, 17 Mar 2024 15:00:02 +0100

libgnatcoll (24.1.20230921-3) experimental; urgency=medium

  * Rebuild with dh-ada-library 9.1 for gnat version in ada:Depends.
  * Improve readability of debian/rules.

 -- Nicolas Boulenguez <nicolas@debian.org>  Wed, 20 Dec 2023 20:30:54 +0000

libgnatcoll (24.1.20230921-2) experimental; urgency=medium

  * Previous upload broke the ABI, update the SOversion in library package.
  * Build-Depend on a libgnatprj-dev version fixing the same issue.

 -- Nicolas Boulenguez <nicolas@debian.org>  Wed, 25 Oct 2023 13:59:00 +0000

libgnatcoll (24.1.20230921-1) experimental; urgency=medium

  * New upstream release.
  * Build in experimental with dh-ada-library >= 9 and gnat >= 13
  * Rename -dev package, now unversioned. Provide a name containing a hash.
  * Build-Depend: gnat instead of gnat-13. Break/Replace previous -devs.

 -- Nicolas Boulenguez <nicolas@debian.org>  Tue, 24 Oct 2023 20:17:11 +0000

=== debian/control ===
--- 
+++ 
@@ -6,12 +6,13 @@
 Build-Depends:
  debhelper-compat (= 13),
 Build-Depends-Arch:
- dh-ada-library (>= 8.1),
+ dh-ada-library (>= 9.1),
  dh-sequence-ada-library,
- gnat-12,
- gprbuild (>= 2021.0.0.0778b109-2),
- libgnatprj10-dev,
+ gnat,
+ gnat-14,
+ gprbuild (>= 2025.0.0-2),
 # Implicit libc6-dev provides: iconv, syslog.
+ libgnatprj-dev,
 Build-Depends-Indep:
  dh-sequence-sphinxdoc,
 # Sphinx >= 1.6 uses the latexmk driver:
@@ -24,14 +25,17 @@
  texlive-fonts-recommended,
  texlive-latex-extra,
 Homepage: https://github.com/AdaCore/gnatcoll-core
-Standards-Version: 4.6.2
+Standards-Version: 4.7.2
 Rules-Requires-Root: no
 Vcs-Browser: https://salsa.debian.org/debian/libgnatcoll
 Vcs-Git: https://salsa.debian.org/debian/libgnatcoll.git
 
-Package: libgnatcoll21-dev
-Breaks: libgnatcoll17-dev, libgnatcoll18-dev, libgnatcoll19-dev, libgnatcoll20-dev
-Replaces: libgnatcoll17-dev, libgnatcoll18-dev, libgnatcoll19-dev, libgnatcoll20-dev
+Package: libgnatcoll-dev
+Breaks: libgnatcoll17-dev, libgnatcoll18-dev, libgnatcoll19-dev,
+ libgnatcoll20-dev, libgnatcoll21-dev
+Replaces: libgnatcoll17-dev, libgnatcoll18-dev, libgnatcoll19-dev,
+ libgnatcoll20-dev, libgnatcoll21-dev
+Provides: ${ada:Provides}
 Architecture: any
 Depends: ${misc:Depends}, ${ada:Depends}
 Suggests: libgnatcoll-doc
@@ -60,7 +64,7 @@
  .
  This package contains the documentation in text, PDF and HTML.
 
-Package: libgnatcoll21
+Package: libgnatcoll22
 # This line is parsed to set the Shared Object version.
 Section: libs
 Architecture: any

=== debian/rules ===
#!/usr/bin/make -f

DPKG_EXPORT_BUILDFLAGS := 1
DEB_BUILD_MAINT_OPTIONS := hardening=+all
DEB_LDFLAGS_MAINT_APPEND := \
  -Wl,--no-allow-shlib-undefined \
  -Wl,--no-copy-dt-needed-entries \
  -Wl,--no-undefined
include /usr/share/dpkg/buildflags.mk
include /usr/share/dpkg/buildopts.mk
include $(wildcard /usr/share/ada/packaging.mk)
# wildcard means: not during -indep builds.

%:
  # Skip Makefile clean and install targets.  Actually, even parsing
  # it would require gprconfig during -indep builds.
	dh $@ --buildsystem=none

project := -Pgnatcoll.gpr -XBUILD=PROD
static := -XLIBRARY_TYPE=static
shared := -XLIBRARY_TYPE=relocatable -XGNATCOLL_VERSION=$(gnatcoll_SO_VERSION)

# Prevent Makefile from messing with gprconfig
# (NORMALIZED_TARGET is wrong at least for i386 and hurd-i386).
override_dh_auto_build-arch:
	gprconfig --batch $(GPRCONFIGFLAGS)
	gprbuild $(project) $(static) $(GPRBUILDFLAGS)
	gprbuild $(project) $(shared) $(GPRBUILDFLAGS)

override_dh_auto_install-arch:
	gprinstall $(project) $(static) $(static_GPRINSTALLFLAGS)
	gprinstall $(project) $(shared) $(call shared_GPRINSTALLFLAGS,gnatcoll)

override_dh_auto_build-indep:
ifeq (,$(filter nodoc,$(DEB_BUILD_OPTIONS)))
  # Write distrib/gnatcoll/runtime.py, present in VCS and debian/clean:
	cd distrib && python3 gen_gps.py
	$(MAKE) -Cdocs html latexpdf text \
	  $(DEB_BUILD_OPTION_PARALLEL:%=SPHINXOPTS=-j%)
endif

=== debian/watch ===
version=4

https://github.com/AdaCore/gnatcoll-core/tags \
(?:.*?/)?v?(\d[\d.]*)\.tar\.gz
